import csv

from data.sig_ref import SIGRef
from providers.sigrefdata.local_file_sig_ref_data_provider import LocalFileSIGRefDataProvider


class Toilets(LocalFileSIGRefDataProvider):
    """SIG ref data provider for Toilets on the Air"""

    SIG = "Toilets"
    PATH = "datafiles/toilets.csv"

    def __init__(self, provider_config):
        super().__init__(self.SIG, provider_config, self.PATH)

    def _file_to_data(self, path):
        new_data = []
        with open(path) as _f:
            csv_data = _f.read()
            dr = csv.DictReader(csv_data.splitlines())
            for row in dr:
                new_data.append(SIGRef(sig=self.SIG, id=row["ref"], name=row["ref"], ref_type="Toilet",
                                       latitude=float(row["lat"]), longitude=float(row["lon"])))

                # Bail out if a stop has been requested, i.e. the program is shutting down - no need to parse the rest
                # of the data in this case
                if self._stop:
                    break

        return new_data
